﻿using System;

namespace Niche.Common
{
    /// <summary>
    /// Arguments class used for the ValueChanged event of the <see cref="Scoped{T}"/> class.
    /// </summary>
    /// <typeparam name="T">Type of value notified.</typeparam>
    public class ValueChangedEventArgs<T> : EventArgs
    {
        /// <summary>
        /// Gets the new value that has been set.
        /// </summary>
        public T Value
        {
            get
            {
                return mValue;
            }
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ValueChangedEventArgs{T}"/> class.
        /// </summary>
        /// <param name="value">The value.</param>
        public ValueChangedEventArgs(T value)
        {
            mValue = value;
        }

        /// <summary>
        /// Storage for the value property
        /// </summary>
        private readonly T mValue;
    }
}
